/*
===============================================================================
OzGtkXML

An XML Parser (simple) to use with config files.

<TopLevel>
    <Entry1 "Value">
    <Entry2 "Value">
    <SubLevel>
	<Entry1 "Value">
    </SubLevel>
</TopLevel>


===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================
*/

#include "../include/common.h"
#include "../include/ozgtkxml.h"


struct _OzGtkXML *OzGtkXML_ParseBuffer(gchar *buffer,gint sob) {
    struct _OzGtkXML *XMLCurr,*XMLTemp,*XMLRoot;
    gchar lbuf[256],*sline,*s_block,*e_block,*s_value;
    guint line=0,block=0,bindex=0,c=0;

    XMLCurr = g_malloc0(sizeof(struct _OzGtkXML));
    XMLRoot = XMLCurr;
    while(bindex < sob) {
	for(c=0;c<256;c++) {
	    lbuf[c] = buffer[bindex];
	    bindex++;	
	    if((buffer[bindex] == '\n')||(buffer[bindex] == '\0')) break;	
	}
	lbuf[c+1] = '\0';
      	line++;
	sline = g_strstrip(lbuf); /* Rimuovi spazi bianchi in cima e in fondo */
#ifdef DEBUG
        g_print("(%d) Sline: %s\n",bindex,sline);
#endif			    
	if(sline[0] == '!') {/* Commento ! */
	    
	} else if((sline[0] == '<')&&(sline[strlen(sline)-1] == '>')) { /* E' un elemento valido */
	    /* Qui esegui il parse dell'elemento */
	    s_block = sline++;
	    e_block = strchr(s_block,'>');
	    if(s_block[1] == '/') { /* Fine di un blocco */
		if(block <= 0) { /* Errore, nessun blocco era iniziato ! */
		
		} else {
		    block--;
		    XMLCurr->Parent->Elements = g_list_append(XMLCurr->Parent->Elements,XMLCurr); /* Aggiunti alla Lista */		    
		    XMLCurr = XMLCurr->Parent; /* Torna indietro */		    
		}
	    } else { /* Inizio di un blocco */
		if(e_block[strlen(e_block)-2] == '"') { /* E' un elemento di dati ? */
		    XMLTemp = g_malloc0(sizeof(struct _OzGtkXML));
		    XMLTemp->Parent = XMLCurr;		    
		    /* Preleva Nome e Dati */
		    s_value = strchr(s_block,'"');
		    g_strlcpy(XMLTemp->name,s_block+1,strlen(s_block)-strlen(s_value)-1);
		    g_strlcpy(XMLTemp->value,s_value+1,strlen(s_value)-2);
#ifdef DEBUG
		    g_print("(%d) value = %s\n",block,XMLTemp->value);
		    g_print("(%d) name = %s\n",block,XMLTemp->name);
#endif			    
		    XMLCurr->Elements = g_list_append(XMLCurr->Elements,XMLTemp); /* Aggiunti alla Lista */
		} else {
		    XMLTemp = g_malloc0(sizeof(struct _OzGtkXML));
		    XMLTemp->Parent = XMLCurr;
		    XMLCurr = XMLTemp;
		    g_strlcpy(XMLCurr->name,s_block+1,strlen(s_block)-1);
#ifdef DEBUG
		    g_print("name = %s\n",XMLCurr->name);
#endif			    
		    block++;
		}			
	    }
	} else {
#ifdef DEBUG
            g_print("Line %d INVALID\n",line);
#endif			    
	    /* Errore, linea non valida */
	}
    }
    return XMLRoot;
}

struct _OzGtkXML *OzGtkXML_ParseFile(gchar *filename) {
    FILE *f;
    gchar *buffer;
    struct stat ffs;
    
    f = fopen(filename,"r");
    if(f == NULL) return (struct _OzGtkXML *)NULL;
    stat(filename,&ffs);
#ifdef DEBUG
    g_print("DEBUG: Size (in bytes): %d\n",ffs.st_size);
#endif
    buffer = g_malloc0(ffs.st_size);
    fread(buffer,ffs.st_size,1,f);
    fclose(f);
    return OzGtkXML_ParseBuffer(buffer,ffs.st_size);
}

gchar *OzGtkXML_GetElementValue(struct _OzGtkXML *XML,gchar *itemname) {
    struct _OzGtkXML *XMLTemp;
    guint n;
    
    for(n=0;n<g_list_length(XML->Elements);n++) {
	XMLTemp = g_list_nth_data(XML->Elements,n);
#ifdef DEBUG
	g_print("%d - %s(%s)\n",n,XMLTemp->name,XMLTemp->value);
#endif	
	if(g_ascii_strncasecmp(XMLTemp->name,itemname,strlen(itemname))==0) {
	    return XMLTemp->value;
	}
    }
}

struct _OzGtkXML *OzGtkXML_GetElementFromName(struct _OzGtkXML *XML,gchar *itemname) {
    struct _OzGtkXML *XMLTemp;
    guint n;
    
    for(n=0;n<g_list_length(XML->Elements);n++) {
	XMLTemp = g_list_nth_data(XML->Elements,n);
#ifdef DEBUG
	g_print("%d - %s(%s)\n",n,XMLTemp->name,XMLTemp->value);
#endif	
	if(g_ascii_strncasecmp(XMLTemp->name,itemname,strlen(itemname))==0) {
	    return (struct _OzGtkXML *)XMLTemp;
	}
    }
}
