/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================

- Rilevare le FUNZIONI ed aggiungerle al Tree View
- Usare moduli per il parsing dei linguaggi

*/

#include "../include/common.h"
#include "../include/parser.h"


/* Definisci Parole Chiave per Linguaggio ANSI C */
static struct _OzEDIT_Token Token[] = {
    {"auto", TOKEN_RESERVEDWORD },
    {"break", TOKEN_RESERVEDWORD },
    {"case", TOKEN_RESERVEDWORD },
    {"char", TOKEN_RESERVEDWORD },
    {"const", TOKEN_RESERVEDWORD },
    {"continue", TOKEN_RESERVEDWORD },
    {"default", TOKEN_RESERVEDWORD },
    {"do", TOKEN_RESERVEDWORD },
    {"double", TOKEN_RESERVEDWORD },
    {"else", TOKEN_RESERVEDWORD },
    {"enum", TOKEN_RESERVEDWORD },
    {"extern", TOKEN_RESERVEDWORD },
    {"float", TOKEN_RESERVEDWORD },
    {"for", TOKEN_RESERVEDWORD },
    {"goto", TOKEN_RESERVEDWORD },
    {"if", TOKEN_RESERVEDWORD },
    {"int", TOKEN_RESERVEDWORD },
    {"long", TOKEN_RESERVEDWORD },
    {"register", TOKEN_RESERVEDWORD },
    {"return", TOKEN_RESERVEDWORD },
    {"short", TOKEN_RESERVEDWORD },
    {"signed", TOKEN_RESERVEDWORD },
    {"sizeof", TOKEN_RESERVEDWORD },
    {"static", TOKEN_RESERVEDWORD },
    {"struct", TOKEN_RESERVEDWORD },
    {"switch", TOKEN_RESERVEDWORD },
    {"typedef", TOKEN_RESERVEDWORD },
    {"union", TOKEN_RESERVEDWORD },
    {"unsigned", TOKEN_RESERVEDWORD },
    {"void", TOKEN_RESERVEDWORD },
    {"volatile", TOKEN_RESERVEDWORD },
    {"while", TOKEN_RESERVEDWORD },
    {"#if", TOKEN_PREPROCESSOR },
    {"#ifdef", TOKEN_PREPROCESSOR },
    {"#ifndef", TOKEN_PREPROCESSOR },
    {"#else", TOKEN_PREPROCESSOR },
    {"#elif", TOKEN_PREPROCESSOR },
    {"#include", TOKEN_PREPROCESSOR },
    {"#define", TOKEN_PREPROCESSOR },
    {"#undef", TOKEN_PREPROCESSOR },
    {"#endif", TOKEN_PREPROCESSOR },
    {"#line", TOKEN_PREPROCESSOR },
    {"#error", TOKEN_PREPROCESSOR },
    {"#warning", TOKEN_PREPROCESSOR },
    {"#pragma", TOKEN_PREPROCESSOR },
    {"/*",TOKEN_STARTCOMMENTBLOCK },
    {"*/",TOKEN_ENDCOMMENTBLOCK }
};

static guint NToken = sizeof(Token) / sizeof(Token[0]);

/* === Parse Text Buffer (and colorize it !) ================================== */
guint OzEDIT_TokenAnalyze(gchar *token) {
    guint i,ttype;
    for(i=0;i<NToken;i++) {
	if(g_ascii_strcasecmp(token,Token[i].data) == 0) { /* Trovato Token ! */
	    return Token[i].type;
	}
    }
    return TOKEN_UNKNOWN;
}	

gboolean is_parentesis(gchar c) {
/* Le parentesi non sono valide ! */
    if((c == '(')||(c == ')')||(c == ']')||(c == '[')||(c == '{')||(c == '}')) {
        return TRUE;
    } else {
	return FALSE;
    }
}

gboolean is_valid(gchar c) {
/* Le parentesi non sono valide ! */
    if((c == '(')||(c == ')')||(c == ']')||(c == '[')||(c == '{')||(c == '}')) return FALSE;
/* Anche ; e : non sono validi ! */
    if((c == ';')||(c == ';')) return FALSE;
    if(c == '\n') return FALSE;
/* ALFABETO+NUMERI+SIMBOLI */
    if((g_unichar_isalnum(c))||(g_unichar_ispunct(c))) {
	return TRUE;
    } else {
	return FALSE;
    }
}

void OzEDIT_ParseTextBuffer(struct _OzEDIT_Object *object) {
    GtkTextIter i_start,i_end,i_cstart,i_cend,i_pstart,i_pend,i_sstart,i_send;
    gchar *buffer,*index,token[256];
    gulong sizeofbuffer,offset,ti;
    gboolean is_comment,is_string;
    /* Verifica se  un TIPO di file che possiamo colorare... */
    if((object->type == OBJECT_TYPE_UNKNOWN)||(object->type == OBJECT_TYPE_NONE)) return;
    /* Crea ITERs */
    gtk_text_buffer_get_start_iter(object->text_buffer,&i_start);
    gtk_text_buffer_get_end_iter(object->text_buffer,&i_end);
    /* Rimuovi tutti i TAGs */
    gtk_text_buffer_remove_all_tags(object->text_buffer,&i_start,&i_end);
    /* Alloca la memoria necessaria */
    sizeofbuffer = gtk_text_buffer_get_char_count(object->text_buffer);
    buffer = g_malloc0(sizeofbuffer);
    /* Prelev il buffer */
    buffer = gtk_text_buffer_get_text(object->text_buffer,&i_start,&i_end,FALSE);
    ti = 0;
    is_string = is_comment = FALSE;
    for(offset = 0;offset < sizeofbuffer;offset++) {
	if((is_parentesis(buffer[offset]))&&(is_comment == FALSE)&&(is_string == FALSE)) {
    	    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_pstart,offset);
	    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_pend,offset+1);
	    gtk_text_buffer_apply_tag(object->text_buffer,object->tag_blue,&i_pstart,&i_pend);
	}
	if(buffer[offset] == '"') {
	    if(!is_comment) {
	        if(is_string == FALSE) {
		    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_sstart,offset);
		    is_string = TRUE;
		} else {
	    	    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_send,offset+1);
		    gtk_text_buffer_apply_tag(object->text_buffer,object->tag_green,&i_sstart,&i_send);
		    is_string = FALSE;
		}
	    }
	} 
	if(is_string == FALSE) {
	    if((is_valid(buffer[offset]))) {  /* Alfanumerico o Simbolo */
		token[ti] = buffer[offset];
		ti++;
		token[ti] = '\0';
		if(ti > 255) ti = 0;
	    } else { /* Altrimenti analizza il TOKEN */
    	        gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_start,offset-strlen(token));
		gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_end,offset);
		switch(OzEDIT_TokenAnalyze(token)) {
	    	    case TOKEN_RESERVEDWORD:
			if(is_comment == FALSE) gtk_text_buffer_apply_tag(object->text_buffer,object->tag_blue,&i_start,&i_end);			    								    
			break;			    
		    case TOKEN_PREPROCESSOR:
			if(is_comment == FALSE) gtk_text_buffer_apply_tag(object->text_buffer,object->tag_red,&i_start,&i_end);
			break;			    
		    case TOKEN_STARTCOMMENTBLOCK:
	    		if(is_comment == FALSE) gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_cstart,offset-strlen(token));
			is_comment = TRUE;
		    case TOKEN_ENDCOMMENTBLOCK:		    
			gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_cend,offset);
			/* Colorize ! */
			gtk_text_buffer_apply_tag(object->text_buffer,object->tag_gray,&i_cstart,&i_cend);			    								    		    
			is_comment = FALSE;
		    default:
			break;
		}
		ti=0;
	    }
	}
    }    
    /* Libera tutto... */
    g_free(buffer);
}
